// $Id: contacts_app.h,v 1.2 2017/04/10 04:37:39 leavens Exp $
#ifndef CONTACTS_APP_H
#define CONTACTS_APP_H 1
#include <stdlib.h>
#include "contact.h"

#define MAX_CONTACT_SIZE 100

// requires: stdin and stdout are open
// modifies: stdin and stdout
// effect: The program has 2 phases after intialization. First it
//         reads contact information from the user, then it answers
//         queries.
//         The reading phase starts by outputting
//           "To start, you can input up to 100 contacts"
//         on stdout. Then the user is asked "Input a contact? [Y/n] ";
//         when the user responds with "n", "N", "No", or "no",
//         the reading phase ends. When the user responds with "Y", "y",
//         "yes", or "Yes", then a contact is read from stdin
//         (with prompts on stdout as specified in contacts.h)
//         and the reading phase continues. The reading phase can also end
//         if 100 contacts are entered.
//         The query phase starts by outputting
//           "Now you can query the database of contacts"
//         on stdout. The user is prompted to enter a command number using
//         the following prompt on stdout:
//           "Choose a command by typing in its number (and a return)"
//           "0 = quit this program,  1 = find contact info. by first name"
//           "2 = find contact info. by last name,  3 = print all contacts"
//           "Command number? "
//         If the user enters 0, then the query phase and the program finishes.
//         If the user enters 1, then the user is prompted for the first name
//         (with "First name to search for? ", on stdout),
//         and the name is read from stdin;
//         then all contacts in the database with that first name are printed
//         (using the format in contact_to_string) to stdout,
//         and the query process repeats.
//         If the user enters 2, then the user is prompted for the last name
//         (with "Last name to search for? ", on stdout),
//         and the name is read from stdin;
//         then all contacts in the database with that last name are printed
//         (using the format in contact_to_string) to stdout,
//         and the query process repeats.
//         If the user enters 3, then each contact in the database is printed,
//         (using the format in contact_to_string) to stdout. The order of
//         printing is the order in which the contacts were entered.
//         Then the query process repeats.
extern int contacts_app();

#endif

