// $Id: test_name.c,v 1.5 2019/04/15 03:42:29 leavens Exp leavens $
// Compile with:
// gcc tap.c testing_io.c name.c test_name.c -o test_name

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tap.h"
#include "testing_io.h"
#include "name.h"

static int test_read_name() {
    for (int i = 0; i < 7; i++) {
	name n = read_name("first name? ",
				 "last name? ");
	if (n == NULL) { continue; }
	printf("read name %d is: \"%s\"\n", i, name_to_string(n));
    }
    return EXIT_SUCCESS;
}

int main() {
    plan(17);
    name ada = make_name("Ada", "Lovelace");
    ok(ada != NULL, "made ada successfully");
    if (ada != NULL) {
	ok(strcmp(ada->first_name, "Ada") == 0,
	   "strcmp(ada->first_name, \"Ada\") == 0");
	ok(strcmp(ada->last_name, "Lovelace") == 0,
	   "strcmp(ada->last_name, \"Lovelace\") == 0");
	ok(strcmp(first_name(ada), "Ada") == 0,
	   "strcmp(first_name(ada), \"Ada\") == 0");
	ok(strcmp(last_name(ada), "Lovelace") == 0,
	   "strcmp(last_name(ada), \"Lovelace\") == 0");
	ok(strcmp(name_to_string(ada), "Ada Lovelace") == 0,
	   "strcmp(name_to_string(ada), \"Ada Lovelace\") == 0");
    }
    
    name alan = make_name("Alan", "Turing");
    ok(alan != NULL, "made alan successfullly");
    if (alan != NULL) {
	ok(strcmp(alan->first_name, "Alan") == 0,
	   "strcmp(alan->first_name, \"Alan\") == 0");
	ok(strcmp(alan->last_name, "Turing") == 0,
	   "strcmp(alan->last_name, \"Turing\") == 0");
	ok(strcmp(first_name(alan), "Alan") == 0,
	   "strcmp(first_name(alan), \"Alan\") == 0");
	ok(strcmp(last_name(alan), "Turing") == 0,
	   "strcmp(last_name(alan), \"Turing\") == 0");
	ok(strcmp(name_to_string(alan), "Alan Turing") == 0,
	   "strcmp(name_to_string(alan), \"Alan Turing\") == 0");
    }

    if (ada != NULL && alan != NULL) {
	ok(equal_name(ada, ada), "equal_name(ada, ada)");
	ok(equal_name(alan, alan), "equal_name(alan, alan)");
	ok(!equal_name(ada, alan), "!equal_name(ada, alan)");
	ok(!equal_name(alan, ada), "!equal_name(alan, ada)");
    }
    testproc(test_read_name, "test_name1");
    return exit_status();
}
