// $Id: test_us_tele.c,v 1.6 2019/04/15 03:21:02 leavens Exp leavens $
// Compile with:
// gcc tap.c testing_io.c us_tele.c test_us_tele.c -o test_us_tele

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tap.h"
#include "testing_io.h"
#include "us_tele.h"

static int test_read_us_tele() {
    for (int i = 0; i < 7; i++) {
	us_tele te = read_us_tele("area code (digits only): ",
				   "number (in the form 555-1212): ");
	if (te == NULL) {
	    continue;
	}
	printf("read phone %d is: \"%s\"\n", i, us_tele_to_string(te));
    }
    return EXIT_SUCCESS;
}

int main() {
    plan(19);
    us_tele teTV = make_us_tele("913", "555", "1212");
    ok(teTV != NULL);
    if (teTV != NULL) {
	ok(teTV->area[0] == 9 && teTV->area[1] == 1 && teTV->area[2] == 3,
	   "teTV->area[0] == 9 && teTV->area[1] == 1 && teTV->area[2] == 3");
	ok(teTV->exchange[0] == 5 && teTV->exchange[1] == 5 && teTV->exchange[2] == 5,
	   "teTV->exchange[0] == 5 && teTV->exchange[1] == 5 && teTV->exchange[2] == 5");
	ok(teTV->subscriber[0] == 1 && teTV->subscriber[1] == 2
	   && teTV->subscriber[2] == 1 && teTV->subscriber[3] == 2,
	   "teTV->subscriber[0] == 4 && teTV->subscriber[1] == 7\n%s",
	   " && teTV->subscriber[2] == 5 && teTV->subscriber[3] == 2");
    }
    
    us_tele teGL = make_us_tele("407", "823", "4758");
    ok(teGL != NULL);
    if (teGL != NULL) {
	ok(teGL->area[0] == 4 && teGL->area[1] == 0 && teGL->area[2] == 7,
	   "teGL->area[0] == 4 && teGL->area[1] == 0 && teGL->area[2] == 7");
	ok(teGL->exchange[0] == 8 && teGL->exchange[1] == 2 && teGL->exchange[2] == 3,
	   "teGL->exchange[0] == 8 && teGL->exchange[1] == 2 && teGL->exchange[2] == 3");
	ok(teGL->subscriber[0] == 4 && teGL->subscriber[1] == 7
	   && teGL->subscriber[2] == 5 && teGL->subscriber[3] == 8,
	   "teGL->subscriber[0] == 4 && teGL->subscriber[1] == 7\n%s",
	   " && teGL->subscriber[2] == 5 && teGL->subscriber[3] == 8");
    }

    if (teTV != NULL && teGL != NULL) {
	ok(strcmp(area_code(teTV), "913") == 0,
	   "strcmp(area_code(teTV), \"913\") == 0, area_code(teTV) == \"%s\"",
	   area_code(teTV));
	ok(strcmp(area_code(teGL), "407") == 0,
	   "strcmp(area_code(teGL), \"407\") == 0, area_code(teGL) == \"%s\"",
	   area_code(teGL));

	ok(strcmp(digits(teTV), "555-1212") == 0,
	   "strcmp(digits(teTV), \"555-1212\") == 0, digits(teTV) == \"%s\"",
	   digits(teTV));
	ok(strcmp(digits(teGL), "823-4758") == 0,
	   "strcmp(digits(teGL), \"823-4758\") == 0, digits(teGL) == \"%s\"", 
	   digits(teGL));

	ok(strcmp(us_tele_to_string(teTV), "(913)555-1212") == 0,
	   "us_tele_to_string(teTV) == \"%s\"", us_tele_to_string(teTV));
	ok(strcmp(us_tele_to_string(teGL), "(407)823-4758") == 0,
	   "us_tele_to_string(teGL) == \"%s\"", us_tele_to_string(teGL));

	ok(equal_us_tele(teTV, teTV), "equal_us_tele(teTV, teTV)");
	ok(equal_us_tele(teGL, teGL), "equal_us_tele(teGL, teGL)");
	ok(!equal_us_tele(teTV, teGL), "!equal_us_tele(teTV, teGL)");
	ok(!equal_us_tele(teGL, teTV), "!equal_us_tele(teGL, teTV)");
    }
    
    testproc(test_read_us_tele, "test_us_tele1");

    
    return exit_status();
}
